# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the Veeroute Studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 7.0.2395
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class CapacityMultiplier(BaseModel):
    """
    Capacity change rate for the specified transport type.
    """ # noqa: E501
    mass: Optional[Union[Annotated[float, Field(le=1000, strict=True, ge=0)], Annotated[int, Field(le=1000, strict=True, ge=0)]]] = Field(default=1, description="Mass multiplier.")
    volume: Optional[Union[Annotated[float, Field(le=1000, strict=True, ge=0)], Annotated[int, Field(le=1000, strict=True, ge=0)]]] = Field(default=1, description="Volume multiplier.")
    capacity_a: Optional[Union[Annotated[float, Field(le=1000, strict=True, ge=0)], Annotated[int, Field(le=1000, strict=True, ge=0)]]] = Field(default=1, description="Additional parameter (A) multiplier.")
    capacity_b: Optional[Union[Annotated[float, Field(le=1000, strict=True, ge=0)], Annotated[int, Field(le=1000, strict=True, ge=0)]]] = Field(default=1, description="Additional parameter (B) multiplier.")
    capacity_c: Optional[Union[Annotated[float, Field(le=1000, strict=True, ge=0)], Annotated[int, Field(le=1000, strict=True, ge=0)]]] = Field(default=1, description="Additional parameter (C) multiplier.")
    __properties: ClassVar[List[str]] = ["mass", "volume", "capacity_a", "capacity_b", "capacity_c"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CapacityMultiplier from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CapacityMultiplier from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "mass": obj.get("mass") if obj.get("mass") is not None else 1,
            "volume": obj.get("volume") if obj.get("volume") is not None else 1,
            "capacity_a": obj.get("capacity_a") if obj.get("capacity_a") is not None else 1,
            "capacity_b": obj.get("capacity_b") if obj.get("capacity_b") is not None else 1,
            "capacity_c": obj.get("capacity_c") if obj.get("capacity_c") is not None else 1
        })
        return _obj


