# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the Veeroute Studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 7.0.2395
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Union
from typing_extensions import Annotated
from vrt_lss_studio.models.time_window_violations import TimeWindowViolations
from typing import Optional, Set
from typing_extensions import Self

class Quality(BaseModel):
    """
    Quality metrics. 
    """ # noqa: E501
    locations_limits_penalty: Union[Annotated[float, Field(le=1000000000, strict=True, ge=0)], Annotated[int, Field(le=1000000000, strict=True, ge=0)]] = Field(description="Amount of fines for violating location's capacity limit.")
    soft_time_window_violations: TimeWindowViolations
    hard_time_window_violations: TimeWindowViolations
    __properties: ClassVar[List[str]] = ["locations_limits_penalty", "soft_time_window_violations", "hard_time_window_violations"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Quality from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of soft_time_window_violations
        if self.soft_time_window_violations:
            _dict['soft_time_window_violations'] = self.soft_time_window_violations.to_dict()
        # override the default output from pydantic by calling `to_dict()` of hard_time_window_violations
        if self.hard_time_window_violations:
            _dict['hard_time_window_violations'] = self.hard_time_window_violations.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Quality from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "locations_limits_penalty": obj.get("locations_limits_penalty"),
            "soft_time_window_violations": TimeWindowViolations.from_dict(obj["soft_time_window_violations"]) if obj.get("soft_time_window_violations") is not None else None,
            "hard_time_window_violations": TimeWindowViolations.from_dict(obj["hard_time_window_violations"]) if obj.get("hard_time_window_violations") is not None else None
        })
        return _obj


