# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the Veeroute Studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 7.0.2395
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from vrt_lss_studio.models.time_window import TimeWindow
from typing import Optional, Set
from typing_extensions import Self

class StopDemand(BaseModel):
    """
    An demand made for a specific stop.
    """ # noqa: E501
    demand_key: Annotated[str, Field(min_length=1, strict=True, max_length=1024)] = Field(description="Demand key.")
    event_key: Annotated[str, Field(min_length=1, strict=True, max_length=1024)] = Field(description="Event key.")
    demand_time_window: Optional[TimeWindow]
    __properties: ClassVar[List[str]] = ["demand_key", "event_key", "demand_time_window"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StopDemand from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of demand_time_window
        if self.demand_time_window:
            _dict['demand_time_window'] = self.demand_time_window.to_dict()
        # set to None if demand_time_window (nullable) is None
        # and model_fields_set contains the field
        if self.demand_time_window is None and "demand_time_window" in self.model_fields_set:
            _dict['demand_time_window'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StopDemand from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "demand_key": obj.get("demand_key"),
            "event_key": obj.get("event_key"),
            "demand_time_window": TimeWindow.from_dict(obj["demand_time_window"]) if obj.get("demand_time_window") is not None else None
        })
        return _obj


