# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the Veeroute Studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 7.0.2395
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class TableDataStats(BaseModel):
    """
    Data statistics.
    """ # noqa: E501
    locations: Annotated[int, Field(le=15001, strict=True, ge=0)] = Field(description="Locations count.")
    orders: Annotated[int, Field(le=15001, strict=True, ge=0)] = Field(description="Orders count.")
    performers: Annotated[int, Field(le=15001, strict=True, ge=0)] = Field(description="Performers count.")
    transports: Annotated[int, Field(le=15001, strict=True, ge=0)] = Field(description="Transports count.")
    hardlinks: Annotated[int, Field(le=15001, strict=True, ge=0)] = Field(description="Hardlinks count.")
    trips: Annotated[int, Field(le=15001, strict=True, ge=0)] = Field(description="Trips count.")
    facts: Annotated[int, Field(le=15001, strict=True, ge=0)] = Field(description="Facts count.")
    external_routing: StrictBool = Field(description="Using external routing.")
    __properties: ClassVar[List[str]] = ["locations", "orders", "performers", "transports", "hardlinks", "trips", "facts", "external_routing"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TableDataStats from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TableDataStats from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "locations": obj.get("locations"),
            "orders": obj.get("orders"),
            "performers": obj.get("performers"),
            "transports": obj.get("transports"),
            "hardlinks": obj.get("hardlinks"),
            "trips": obj.get("trips"),
            "facts": obj.get("facts"),
            "external_routing": obj.get("external_routing")
        })
        return _obj


