# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the Veeroute Studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 7.0.2395
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from vrt_lss_studio.models.attribute import Attribute
from vrt_lss_studio.models.box import Box
from vrt_lss_studio.models.transport_compatibilities import TransportCompatibilities
from vrt_lss_studio.models.transport_limits import TransportLimits
from vrt_lss_studio.models.transport_shift import TransportShift
from vrt_lss_studio.models.transport_type import TransportType
from typing import Optional, Set
from typing_extensions import Self

class Transport(BaseModel):
    """
    Transport. Used by performer for relocating and cargo transfer. 
    """ # noqa: E501
    key: Annotated[str, Field(min_length=1, strict=True, max_length=1024)] = Field(description="Transport key, unique identifier.")
    shifts: Annotated[List[TransportShift], Field(min_length=1, max_length=15001)] = Field(description="List of working shifts of transport.")
    transport_type: Optional[TransportType] = None
    boxes: Optional[Annotated[List[Box], Field(min_length=0, max_length=100)]] = Field(default=None, description="A list of transport boxes that can accommodate the cargo.")
    compatibilities: Optional[TransportCompatibilities] = None
    limits: Optional[TransportLimits] = None
    attributes: Optional[Annotated[List[Attribute], Field(min_length=0, max_length=1000)]] = Field(default=None, description="Attributes. Used to add service information.")
    __properties: ClassVar[List[str]] = ["key", "shifts", "transport_type", "boxes", "compatibilities", "limits", "attributes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Transport from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in shifts (list)
        _items = []
        if self.shifts:
            for _item in self.shifts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['shifts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in boxes (list)
        _items = []
        if self.boxes:
            for _item in self.boxes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['boxes'] = _items
        # override the default output from pydantic by calling `to_dict()` of compatibilities
        if self.compatibilities:
            _dict['compatibilities'] = self.compatibilities.to_dict()
        # override the default output from pydantic by calling `to_dict()` of limits
        if self.limits:
            _dict['limits'] = self.limits.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in attributes (list)
        _items = []
        if self.attributes:
            for _item in self.attributes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['attributes'] = _items
        # set to None if compatibilities (nullable) is None
        # and model_fields_set contains the field
        if self.compatibilities is None and "compatibilities" in self.model_fields_set:
            _dict['compatibilities'] = None

        # set to None if limits (nullable) is None
        # and model_fields_set contains the field
        if self.limits is None and "limits" in self.model_fields_set:
            _dict['limits'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Transport from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "key": obj.get("key"),
            "shifts": [TransportShift.from_dict(_item) for _item in obj["shifts"]] if obj.get("shifts") is not None else None,
            "transport_type": obj.get("transport_type"),
            "boxes": [Box.from_dict(_item) for _item in obj["boxes"]] if obj.get("boxes") is not None else None,
            "compatibilities": TransportCompatibilities.from_dict(obj["compatibilities"]) if obj.get("compatibilities") is not None else None,
            "limits": TransportLimits.from_dict(obj["limits"]) if obj.get("limits") is not None else None,
            "attributes": [Attribute.from_dict(_item) for _item in obj["attributes"]] if obj.get("attributes") is not None else None
        })
        return _obj


