# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the Veeroute Studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)

    The version of the OpenAPI document: 7.0.2395
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from vrt_lss_studio.models.trip_start_time_strategy import TripStartTimeStrategy
from typing import Optional, Set
from typing_extensions import Self

class TripExpectations(BaseModel):
    """
    Expectations from the calculation result. Affect the calculation logic. 
    """ # noqa: E501
    trip_start_time_strategy: Optional[TripStartTimeStrategy] = None
    pass_max_locations_limits_penalty: Optional[StrictBool] = Field(default=True, description="Defines behavior if the resulting solution does not satisfy the `max_locations_limits_penalty` requirement.   * `true` - in case of violation, the result will still be returned, but the response will contain an appropriate warning.   * `false` - in case of violation, an empty list of flights will be returned. ")
    __properties: ClassVar[List[str]] = ["trip_start_time_strategy", "pass_max_locations_limits_penalty"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TripExpectations from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TripExpectations from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "trip_start_time_strategy": obj.get("trip_start_time_strategy"),
            "pass_max_locations_limits_penalty": obj.get("pass_max_locations_limits_penalty") if obj.get("pass_max_locations_limits_penalty") is not None else True
        })
        return _obj


